

library("abc")
require("abc.data")


canton <- "GE"
cases_deaths <- read.xlsx("cases_deaths.xlsx", sheetName="GE")
casedeath_dates <- as.Date(cases_deaths[,1])
data_cases <- cases_deaths[,2]
data_deaths <- cases_deaths[,3]
data_hosps <- cases_deaths[,4]
data_inhosp <- cases_deaths[,5]
data_inICU <- cases_deaths[,6]

trf <- function(arg) {
  return(arg)
}

target_hosp <- trf(data_hosps)
target_deaths <- trf(data_deaths)

modelsolution <- "stochastic"

sumstat_hosp <- matrix(ncol=56, nrow=10000)

sumstat_deaths <- matrix(ncol=56, nrow=10000)

toler_hosp <- rep(0.01, length=56)
toler_deaths <- rep(0.01, length=56)


#max_days <- 300 # total duration of simulation in days
epsilon <- 1/3.7 # E to Ip
mu_p <- 1/1.5 # Ip to Ia/Ips/Ims/Iss
mu <- 1/2.3 # Ia/Ips/Ims to recovery; Iss to hospitalization (assumed to be equal)
p_aC <- 0.5 # Probability to be asymptomatic: children
p_aA <- 0.5 # Probability to be asymptomatic: adults
p_aS <- 0.5 # Probability to be asymptomatic: seniors
p_msC <- 0 # If symptomatic, probability to have mild symptoms (but excluding paucisymptomatic): children
p_msA <-0.7 # ...
p_msS <- 0.6 # ...
p_ssC <- 0 # If symptomatic, probability to have severe symptoms: children
p_ssA <- 0.03 #0.1 #...
p_ssS <- 0.35 #0.2 # ...
p_ICUC <- 0 # If hospitalized, probability to go to ICU: children
p_ICUA <- 0.25 #0.36 # ...
p_ICUS <- 0.2 #0.2 # ...
lambdaHRC <- 0 # H to R: children
lambdaHRA <- 0.072 # ...
lambdaHRS <- 0.022 # ...
lambdaHDC <- 0
#lambdaHDA <- 2*0.0042 # ...
#lambdaHDS <- 4*0.014 # ...
lambdaICURC <- 0
lambdaICURA <- 0.05 # ...
lambdaICURS <- 0.036 # ...
lambdaICUDC <- 0
#lambdaICUDA <- 2*0.0074 # ...
#lambdaICUDS <- 4*0.029 # ...
rb <- 0.51 # relative infectiousness of prodomic, asymptomatic and paucisymptomatic individuals$


lambdaHDA <- 0.009483796
lambdaHDS <- 0.02826953
lambdaICUDA <- 0.016140518
lambdaICUDS <- 0.27265618
#start_date_fixed <- as.Date("2020/02/08")
#beta0 <- 0.31 #0.8945111
schoolCC <- 0.05488696
schoolCA <- 0.9311092
workAA <- 0.2116836
shopAA <- 0.3898732
social1 <- 0.8950454
social2 <- 0.5192640
#inseed <- 15



#beta0 <- 0.8 # 0.74

relCC <- 2
relCA <- 0.5
relCS <- 0.2
relAS <- 0.4
relSS <- 1

#schoolCC <- 0.05
#schoolCA <- 0.8
#workAA <- 0.5
#shopAA <- 0.5 #0.5
#social1 <- 0.75
#social2 <- 0.75*0.65
restaurantAA <- 0.8

#inseed <- 5

#lambdaHDA_prior <- c(0.0042, 3*0.0042)
#lambdaHDS_prior <- c(0.014, 10*0.014)
#lambdaICUDA_prior <- c(0.0074, 3*0.0074)
#lambdaICUDS_prior <- c(0.029, 10*0.029)
start_date_fixed_prior <- seq(from=as.Date("2020/01/18"), to=as.Date("2020/02/18"), by=1) #seq(from=as.Date("2020/02/01"), to=as.Date("2020/02/18"), by=1)
beta0_prior <- c(0.2, 0.6) #c(0.3, 0.8)
#schoolCC_prior <- c(0.02, 0.1)
#schoolCA_prior <- c(0.5, 1)
#workAA_prior <- c(0.2, 0.8)
#shopAA_prior <- c(0.2, 0.8)
#social1_prior <- c(0.5, 1)
#social2_prior <- c(0.5, 0.8)
#inseed_prior <- seq(from=10,18,by=1)
rb2_prior <- c(0.1, 0.33)
lambdap_prior <- c(1/11, 1)

freeparams <- as.data.frame(matrix(ncol=15, nrow=10000)) 

freeparams[,1] <- 0.0094 # runif(nrow(freeparams), lambdaHDA_prior[1], lambdaHDA_prior[2])
freeparams[,2] <- 0.0282 # runif(nrow(freeparams), lambdaHDS_prior[1], lambdaHDS_prior[2])
freeparams[,3] <- 0.0161 #runif(nrow(freeparams), lambdaICUDA_prior[1], lambdaICUDA_prior[2])
freeparams[,4] <- 0.2727 #runif(nrow(freeparams), lambdaICUDS_prior[1], lambdaICUDS_prior[2])
freeparams[,5] <- sample(start_date_fixed_prior, nrow(freeparams), replace=TRUE)
freeparams[,6] <- runif(nrow(freeparams), beta0_prior[1], beta0_prior[2])
freeparams[,7] <- 0.054 # runif(nrow(freeparams), schoolCC_prior[1], schoolCC_prior[2])
freeparams[,8] <- 0.931 #runif(nrow(freeparams), schoolCA_prior[1], schoolCA_prior[2])
freeparams[,9] <- 0.212 # runif(nrow(freeparams), workAA_prior[1], workAA_prior[2])
freeparams[,10] <- 0.398 # runif(nrow(freeparams), shopAA_prior[1], shopAA_prior[2])
freeparams[,11] <- 0.894 #runif(nrow(freeparams), social1_prior[1], social1_prior[2])
freeparams[,12] <- 0.519 #runif(nrow(freeparams), social2_prior[1], social2_prior[2])
freeparams[,13] <- 15 # sample(inseed_prior, nrow(freeparams), replace=TRUE)
freeparams[,14] <- runif(nrow(freeparams), rb2_prior[1], rb2_prior[2])
freeparams[,15] <- runif(nrow(freeparams), lambdap_prior[1], lambdap_prior[2])



for (runnr in (1:10000)) {
  
  lambdaHDA <- freeparams[runnr,1]
  lambdaHDS <- freeparams[runnr,2]
  lambdaICUDA <- freeparams[runnr,3]
  lambdaICUDS <- freeparams[runnr,4]
  start_date_fixed <- freeparams[runnr,5]
  beta0 <- freeparams[runnr,6]
  schoolCC <- freeparams[runnr,7]
  schoolCA <- freeparams[runnr,8]
  workAA <- freeparams[runnr,9]
  shopAA <- freeparams[runnr,10]
  social1 <- freeparams[runnr,11]
  social2 <- freeparams[runnr,12]
  inseed <- freeparams[runnr,13]
  rb2 <- freeparams[runnr,14]
  lambdap <- freeparams[runnr,15]
  
  source("model_GE_postsymp.R")
  start_relative <- as.numeric(as.Date("2020/02/25")-start_date_fixed+1)
  sumstat_hosp[runnr,] <- trf(newhosps_C[start_relative:(start_relative+55)]+newhosps_A[start_relative:(start_relative+55)]+newhosps_S[start_relative:(start_relative+55)])
  sumstat_deaths[runnr,] <- trf(newdeaths_C[start_relative:(start_relative+55)]+newdeaths_A[start_relative:(start_relative+55)]+newdeaths_S[start_relative:(start_relative+55)])
}


abcresult <- abc(target=c(target_hosp, target_deaths), param=freeparams, sumstat=cbind(sumstat_hosp, sumstat_deaths), tol=c(toler_hosp, toler_deaths), method="rejection")

squaresum <- numeric(length=10000)
for (i in (1:10000)) {
  squaresum[i] = sum((target_deaths-sumstat_deaths[i,])^2)
}



i <- i+1
#runnr <- 734
lambdaHDA <- 0.0094 #freeparams[runnr,1]
lambdaHDS <- 0.0282 #freeparams[runnr,2]
lambdaICUDA <- 0.0161 #freeparams[runnr,3]
lambdaICUDS <- 0.2727 #freeparams[runnr,4]
start_date_fixed <- as.Date("2020/01/30") #freeparams[i,5] #as.Date("2020/02/02") #as.Date("2020/02/18") #
beta0 <- freeparams[i,6]+0.01 #0.46 #0.894 #
schoolCC <- 0.054 #freeparams[runnr,7]
schoolCA <- 0.931 #freeparams[runnr,8]
workAA <- 0.212 #freeparams[runnr,9]
shopAA <- 0.398 #freeparams[runnr,10]
social1 <- 0.895 #freeparams[runnr,11]
social2 <- 0.519-0.1 #freeparams[runnr,12]
inseed <- 15 #freeparams[runnr,13]
rb2 <- freeparams[i,14]
lambdap <- freeparams[i,15]




#start_date_fixed <- as.Date(abcresult$unadj.values[i,1])
#beta0 <- as.numeric(abcresult$unadj.values[i,2])
#inseed <- as.numeric(abcresult$unadj.values[i,3])
#rb2 <- as.numeric(abcresult$unadj.values[i,4])
#lambdap <- as.numeric(abcresult$unadj.values[i,5])

source("model_GE_postsymp.R")
start_relative <- as.numeric(as.Date("2020/02/25")-start_date_fixed+1)
model_hosps <- trf(newhosps_C[start_relative:(start_relative+55)]+newhosps_A[start_relative:(start_relative+55)]+newhosps_S[start_relative:(start_relative+55)])
model_deaths <- trf(newdeaths_C[start_relative:(start_relative+55)]+newdeaths_A[start_relative:(start_relative+55)]+newdeaths_S[start_relative:(start_relative+55)])

plot(x=casedeath_dates, y=data_hosps, ylim=c(0,200))
lines(x=casedeath_dates, y=model_hosps)

plot(x=casedeath_dates, y=data_deaths, ylim=c(0,50))
lines(x=casedeath_dates, y=model_deaths)


##########







