

library("abc")
require("abc.data")


canton <- "Total"
cases <- read.xlsx("covid_19_data_switzerland 110520.xlsx", sheetName="Cases")
cases_dates <- as.Date(cases[,1])
data_cases <- c(0, diff(cases[,28]))
deaths <- read.xlsx("covid_19_data_switzerland 110520.xlsx", sheetName="Fatalities")
deaths_date <- as.Date(deaths[,1])
data_deaths <- c(0, diff(deaths[,28]))
inhosp <- read.xlsx("covid_19_data_switzerland 110520.xlsx", sheetName="Hospitalized")
inhosp_date <- as.Date(inhosp[,1])
data_inhosp <- inhosp[,28]
inICU <- read.xlsx("covid_19_data_switzerland 110520.xlsx", sheetName="ICU")
inICU_date <- as.Date(inICU[,1])
data_inICU <- inICU[,28]



trf <- function(arg) {
  return(arg)
}

#target_hosp <- trf(data_hosps)
target_deaths <- trf(data_deaths[1:(length(data_deaths)-5)])



modelsolution <- "combined"

#sumstat_hosp <- matrix(ncol=60, nrow=1000)

sumstat_deaths <- matrix(ncol=length(data_deaths)-5, nrow=10000)

#toler_hosp <- rep(0.01, length=60)
toler_deaths <- rep(0.01, length=length(data_deaths)-5)


#max_days <- 300 # total duration of simulation in days
epsilon <- 1/3.7 # E to Ip
mu_p <- 1/1.5 # Ip to Ia/Ips/Ims/Iss
mu <- 1/2.3 # Ia/Ips/Ims to recovery; Iss to hospitalization (assumed to be equal)
p_aC <- 0.5 # Probability to be asymptomatic: children
p_aA <- 0.5 # Probability to be asymptomatic: adults
p_aS <- 0.5 # Probability to be asymptomatic: seniors
p_msC <- 0 # If symptomatic, probability to have mild symptoms (but excluding paucisymptomatic): children
p_msA <-0.7 # ...
p_msS <- 0.6 # ...
p_ssC <- 0 # If symptomatic, probability to have severe symptoms: children
p_ssA <- 0.03 #0.1 #...
p_ssS <- 0.35 #0.2 # ...
p_ICUC <- 0 # If hospitalized, probability to go to ICU: children
p_ICUA <- 0.25 #0.36 # ...
p_ICUS <- 0.2 #0.2 # ...
lambdaHRC <- 0 # H to R: children
lambdaHRA <- 0.072 # ...
lambdaHRS <- 0.022 # ...
lambdaHDC <- 0
#lambdaHDA <- 2*0.0042 # ...
#lambdaHDS <- 4*0.014 # ...
lambdaICURC <- 0
lambdaICURA <- 0.05 # ...
lambdaICURS <- 0.036 # ...
lambdaICUDC <- 0
#lambdaICUDA <- 2*0.0074 # ...
#lambdaICUDS <- 4*0.029 # ...
rb <- 0.51 # relative infectiousness of prodomic, asymptomatic and paucisymptomatic individuals


#beta0 <- 0.8 # 0.74

relCC <- 2
relCA <- 0.5
relCS <- 0.2
relAS <- 0.4
relSS <- 1

#schoolCC <- 0.05
#schoolCA <- 0.8
#workAA <- 0.5
#shopAA <- 0.5 #0.5
#social1 <- 0.75
#social2 <- 0.75*0.65
restaurantAA <- 0.8

#inseed <- 5

lambdaHDA_prior <- c(0.009,0.012) #c(0.0042, 3*0.0042)
lambdaHDS_prior <- c(0.025,0.030) #c(0.014, 10*0.014)
lambdaICUDA_prior <- c(0.014,0.018) #c(0.0074, 3*0.0074)
lambdaICUDS_prior <- c(0.2,0.4) #0c(0.029, 10*0.029)
start_date_fixed_prior <- seq(from=as.Date("2020/01/15"), to=as.Date("2020/02/15"), by=1) #seq(from=as.Date("2020/02/01"), to=as.Date("2020/02/25"), by=1)
beta0_prior <- c(0.724, 0.983)
schoolCC_prior <- c(0.043, 0.079)
schoolCA_prior <- c(0.506, 0.931)
workAA_prior <- c(0.212, 0.432)
shopAA_prior <- c(0.266, 0.398)
social1_prior <- c(0.514, 0.895)
social2_prior <- c(0.506, 0.688)
inseed_prior <- seq(from=40,to=100,by=1)

freeparams <- as.data.frame(matrix(ncol=10, nrow=10000)) 

freeparams[,1] <- runif(nrow(freeparams), lambdaHDA_prior[1], lambdaHDA_prior[2])
freeparams[,2] <- runif(nrow(freeparams), pmax(lambdaHDS_prior[1], freeparams[,1]), lambdaHDS_prior[2])
freeparams[,3] <- runif(nrow(freeparams), pmax(lambdaICUDA_prior[1], freeparams[,1]), lambdaICUDA_prior[2])
freeparams[,4] <- runif(nrow(freeparams), pmax(lambdaICUDS_prior[1], freeparams[,3]), lambdaICUDS_prior[2])
freeparams[,5] <- sample(start_date_fixed_prior, nrow(freeparams), replace=TRUE)
freeparams[,6] <- runif(nrow(freeparams), beta0_prior[1], beta0_prior[2])
freeparams[,7] <- runif(nrow(freeparams), schoolCC_prior[1], schoolCC_prior[2])
freeparams[,8] <- runif(nrow(freeparams), schoolCA_prior[1], schoolCA_prior[2])
freeparams[,9] <- runif(nrow(freeparams), workAA_prior[1], workAA_prior[2])
freeparams[,10] <- runif(nrow(freeparams), shopAA_prior[1], shopAA_prior[2]) 
freeparams[,11] <- runif(nrow(freeparams), social1_prior[1], social1_prior[2])
freeparams[,12] <- runif(nrow(freeparams), social2_prior[1], pmin(social2_prior[2],freeparams[,11]))
freeparams[,13] <- sample(inseed_prior, nrow(freeparams), replace=TRUE)


for (runnr in (1:10000)) {
  lambdaHDA <- freeparams[runnr,1]
  lambdaHDS <- freeparams[runnr,2]
  lambdaICUDA <- freeparams[runnr,3]
  lambdaICUDS <- freeparams[runnr,4]
  start_date_fixed <- freeparams[runnr,5]
  beta0 <- freeparams[runnr,6]
  schoolCC <- freeparams[runnr,7]
  schoolCA <- freeparams[runnr,8]
  workAA <- freeparams[runnr,9]
  shopAA <- freeparams[runnr,10]
  social1 <- freeparams[runnr,11]
  social2 <- freeparams[runnr,12]
  inseed <- freeparams[runnr,13]
  
  source("model_GE.R")
  start_relative <- as.numeric(as.Date("2020/02/25")-start_date_fixed+1)
  #sumstat_hosp[runnr,] <- trf(newhosps_C[start_relative:(start_relative+71)]+newhosps_A[start_relative:(start_relative+71)]+newhosps_S[start_relative:(start_relative+71)])
  sumstat_deaths[runnr,] <- trf(newdeaths_C[start_relative:(start_relative+71)]+newdeaths_A[start_relative:(start_relative+71)]+newdeaths_S[start_relative:(start_relative+71)])
}


squaresum <- numeric(length=10000)
for (i in (1:10000)) {
  squaresum[i] = sum((target_deaths-sumstat_deaths[i,])^2)
}




abcresult <- abc(target=target_deaths, param=freeparams, sumstat=sumstat_deaths, tol=toler_deaths, method="rejection")
i <- 0
#model_deaths_mat <- matrix(0, nrow=10, ncol=72)
#start_relative_vec <- numeric(length=10)
  

#i <- i+1

lambdaHDA <- freeparams[i,1] #as.numeric(abcresult$unadj.values[i,1])
lambdaHDS <- freeparams[i,2] #as.numeric(abcresult$unadj.values[i,2])
lambdaICUDA <- freeparams[i,3] #as.numeric(abcresult$unadj.values[i,3])
lambdaICUDS <- freeparams[i,4] #as.numeric(abcresult$unadj.values[i,4])
start_date_fixed <- freeparams[i,5] #as.Date(abcresult$unadj.values[i,5])
beta0 <- freeparams[i,6] #as.numeric(abcresult$unadj.values[i,6])
schoolCC <- freeparams[i,7] #as.numeric(abcresult$unadj.values[i,7])
schoolCA <- freeparams[i,8] #as.numeric(abcresult$unadj.values[i,8])
workAA <- freeparams[i,9] #as.numeric(abcresult$unadj.values[i,9])
shopAA <- freeparams[i,10] #as.numeric(abcresult$unadj.values[i,10])
social1 <- freeparams[i,11] #as.numeric(abcresult$unadj.values[i,11])
social2 <- freeparams[i,12] #as.numeric(abcresult$unadj.values[i,12])
inseed <- freeparams[i,13] #as.numeric(abcresult$unadj.values[i,13])

source("model_GE.R")
start_relative <- as.numeric(min(deaths_date)-start_date_fixed+1)
#model_hosps <- trf(newhosps_C[start_relative:(start_relative+55)]+newhosps_A[start_relative:(start_relative+55)]+newhosps_S[start_relative:(start_relative+55)])
model_deaths <- trf(newdeaths_C[start_relative:(start_relative+71)]+newdeaths_A[start_relative:(start_relative+71)]+newdeaths_S[start_relative:(start_relative+71)])
#start_relative_vec[i] <- start_relative
#model_deaths_mat[i,] <- model_deaths
#plot(x=casedeath_dates, y=data_hosps, ylim=c(0,50))
#lines(x=casedeath_dates[1:56], y=model_hosps)

plot(x=deaths_date, y=data_deaths, ylim=c(0,100))
lines(x=deaths_date[1:length(model_deaths)], y=model_deaths)


##########







